Домашний интернет: маршрутизация двух (и боле) провайдеров на основе Bird Routing Daemon

в 10:44, , рубрики: linux, два провайдера, домашний интернет, Песочница, системное администрирование, метки: , ,

Наверное многие пользователи домашнего интернета сталкивались с тем, как распараллелить два и более интернет-канала в домашней сети.
Эта проблему можно решить и хардварно (используя любое дешевое либо дорогое оборудование) и софтверно.
Какую же модель маршрутизации выбрать? Сразу можно отбросить RIP/OSPF/BGP, так как это домашний интернет и больше чем уверен (в моем случае и проверено), что вам не захотят делать поддержку на стороне провайдера бесплатно.
Остановил выбор на bird.

Итак, исходная позиция:

  • Домашний раутер с Debian GNU/Linux 6.0.5 (squeeze) на борту
  • 2 интернет канала (ISP1 и ISP2)
  • 2 прямые руки
  • чашка кофе


Конфигурация моей сети:

  • eth0 — Провайдер 'ISP1':
    • IP: 10.10.10.106
    • Netmask: 255.255.255.0
    • Gateway: 10.10.10.1

  • eth1 — Локальная сеть:
    • IP: 192.168.254.254
    • Netmask: 255.255.255.0

  • eth2 — Провайдер 'ISP2':
    • IP: 172.17.5.105
    • Netmask: 255.255.255.0
    • Gateway: 172.17.5.1

Я любитель apt, однако как оказалось, в апте лежит довольно устаревшая версия bird (1.2.5-1) и там нет поддержки multipath.
Придется собрать это руками. Заранее намеренно опускаю всякий флейм, как не превратить debian в slackware.

# mkdir -p /usr/local/src/bird && cd /usr/local/src/bird
# wget ftp://bird.network.cz/pub/bird/bird-1.3.8.tar.gz
# tar xf bird-1.3.8.tar.gz
# cd bird-1.3.8
# ./configure --prefix=/usr --sysconfdir=/etc/bird --localstatedir=/var
# make
# make install

Как оказалось, в сорцах нет стартап-скрипта для Debian.
Генерируем стартап-скрипт (нагло взят из того же устаревшего пакета в апт-е и немного подкорректировав) /etc/init.d/bird с таким содержанием:

#! /bin/sh
### BEGIN INIT INFO
# Provides:          bird
# Required-Start:    $remote_fs $syslog
# Required-Stop:     $remote_fs $syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
### END INIT INFO

# Author: Ondřej Surý <ondrej@sury.org>
#

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="Internet routing daemon"
NAME=bird
DAEMON=/usr/sbin/$NAME
DAEMON_ARGS="-c /etc/bird/bird.conf"
#PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
        # Return
        #   0 if daemon has been started
        #   1 if daemon was already running
        #   2 if daemon could not be started
        start-stop-daemon --start --quiet --name $NAME --exec $DAEMON --test > /dev/null 
                || return 1
        start-stop-daemon --start --quiet --name $NAME --exec $DAEMON -- 
                $DAEMON_ARGS 
                || return 2
        # Add code here, if necessary, that waits for the process to be ready
        # to handle requests from services started subsequently which depend
        # on this one.  As a last resort, sleep for some time.
}

#
# Function that stops the daemon/service
#
do_stop()
{
        # Return
        #   0 if daemon has been stopped
        #   1 if daemon was already stopped
        #   2 if daemon could not be stopped
        #   other if a failure occurred
        start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --name $NAME --exec $DAEMON
        RETVAL="$?"
        [ "$RETVAL" = 2 ] && return 2
        # Wait for children to finish too if this is a daemon that forks
        # and if the daemon is only ever run from this initscript.
        start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --name $NAME --exec $DAEMON
        [ "$?" = 2 ] && return 2
        return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
        #
        # If the daemon can reload its configuration without
        # restarting (for example, when it is sent a SIGHUP),
        # then implement that here.
        #
        start-stop-daemon --stop --signal 1 --quiet --name $NAME --exec $DAEMON
        return 0
}

case "$1" in
  start)
        [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
        do_start
        case "$?" in
                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
  stop)
        [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
        do_stop
        case "$?" in
                0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
                2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
        esac
        ;;
  reload|force-reload)
        #
        # If do_reload() is not implemented then leave this commented out
        # and leave 'force-reload' as an alias for 'restart'.
        #
        log_daemon_msg "Reloading $DESC" "$NAME"
        do_reload
        log_end_msg $?
        ;;
  restart)
        log_daemon_msg "Restarting $DESC" "$NAME"
        do_stop
        case "$?" in
          0|1)
                do_start
                case "$?" in
                        0) log_end_msg 0 ;;
                        1) log_end_msg 1 ;; # Old process is still running
                        *) log_end_msg 1 ;; # Failed to start
                esac
                ;;
          *)
                # Failed to stop
                log_end_msg 1
                ;;
        esac
        ;;
  *)
        echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
        exit 3
        ;;
esac

Стартап-скрипт готов, добавляем в авто-запуск:

# chmod +x /etc/init.d/bird
# update-rc.d bird enable
update-rc.d: using dependency based boot sequencing

Создадим директорию для логфайла:

# mkdir /var/log/bird

Теперь приступаем к конфигурированию самого bird.

Для начала, бакапим оригинальный конфиг и создаем новый:

# cd /etc/bird
# mv bird.conf bird-orig.conf
# :> bird.conf

Затем открываем его на редактирование:

# 
# Logging
#
# Уровни логгирования.
# all эквивалентно { debug, trace, info, remote, warning, error, auth, fatal, bug }
# Например, мы хотим получить 2 отдельных файла с разными уровнями (в этом случае, две нижеследующие строчки следует раскомментировать):
#        log "/var/log/bird/debug.log" { debug };
#        log "/var/log/bird/warning.log" { warning };
log "/var/log/bird/bird.log" all;

# Router ID:
# Тут пишем IP-адрес вашей сетевой карты, которая смотрит в вашу домашнюю (не провайдера!) локалку.
router id 192.168.254.254;

#
# Debugging
#
# Уровни дебага:
# all | off | { states, routes, filters, interfaces, events, packets }
debug protocols { routes, interfaces };

#
# Protocols
# 
# Сетевые устройства, которые будут мониториться на предмет смены маршрутов (в мойм случае - это eth0 и eth2)
protocol direct {
        interface "eth0", "eth2";
}

#
# Tables
#
# Названия таблиц маршрутизации
# Описываем провайдеров ISP1 и ISP2:
table ISP_ISP1;
table ISP_ISP2;
# Таблица "другие":
table other;
# Таблица "master" - основная таблица маршрутизации (main). Внимание, указывать main нельзя!
table master;

#
# Protocol 'static'
#

protocol static {
        table ISP_ISP1;
        description "Home internet ISP1";
        check link on;
        preference 100;
        route 0.0.0.0/0 via 10.10.10.1;
}

protocol static {
        table ISP_ISP2;
        description "Home internet ISP2";
        check link on;
        preference 150;
        route 0.0.0.0/0 via 172.17.5.1;
}

protocol static {
        table other;
        description "Other custom static routes";
        preference 200;
        # Включение всех конфигов (если есть в наличие) в /etc/bird/static_route.d/
        include "/etc/bird/static_route.d/*.conf";
}

protocol static {
        table master;
        description "Common Table";
        # Это главная таблица, сюда вписываются все default-маршруты
        route 0.0.0.0/0 multipath
                    via 10.10.10.1
                    via 172.17.5.1;
}

#
# Protocol 'kernel'
#
# Обратите внимание на комментарий в 'debug all'. Советую раскомментировать только на момент запуска или дебага.
# Оставлять дебаг с 'all' не советую. В противном случае, ваш лог-файл вырастет в сотни мегабайт, а то и больше.
# 
# Опция 'persist' - не дает bird убирать маршруты, созданные им, после выключения (или нештатного "падения") bird.
# Опция 'learn' - указывает, что bird будет "изучать" все маршруты, которые были добавлены внешними средствами
# в таблицу 10/11/254 (далее мы разберем, что такое 10, 11, 254).
#
protocol kernel {
        table ISP_ISP1;
        persist;
        learn;
        scan time 20;
        kernel table 10;
        export all;
#       debug all;
}

protocol kernel {
        table ISP_ISP2;
        persist;
        learn;
        scan time 20;
        kernel table 11;
        export all;
#       debug all;
}

protocol kernel {
        table master;
        persist;
        learn;
        scan time 20;
        kernel table 254;
        export all;
#       debug all;
}

#
# Protocol 'pipe.
#
# Главная таблица (default).
# Тут мы указываем, что в главную таблицу master будут импортироваться все маршруты, указанные в статических протоколах, описанных в ISP_ISP1, ISP_ISP2 и other.
protocol pipe {
        table master;
        peer table ISP_ISP1;
        peer table ISP_ISP2;
        peer table other;
        import all;
#       debug all;
}

Теперь создаем директорию для мануальных конфигов и для примера вносим некоторые маршруты:

# mkdir /etc/bird/static_route.d/
# cat << EOF >/etc/bird/static_route.d/ISP1_LAN.conf
    route 10.0.5.0/24  via 10.10.10.1;
    route 175.5.25.0/27 via 10.10.10.1;   # сеть взята "с потолка", подразумевается, что это сеть белых IP провайдера ISP1
EOF
# cat << EOF >/etc/bird/static_route.d/ISP2_LAN.conf
    route 194.22.253.23/27  via 172.17.5.1;    # сеть взята "с потолка", подразумевается, что это сеть белых IP провайдера ISP2
    route 5.9.0.0/16 via 172.17.5.1;   # сеть взята "с потолка", подразумевается, что это сеть белых IP провайдера ISP2
EOF

Все, настройка bird закончена.
Теперь переходим к настройке таблиц маршрутизации.

Добавляем таблицы в /etc/iproute2/rt_tables:

# cat << EOF >>/etc/iproute2/rt_tables

10       ISP1
11       ISP2
EOF

Теперь нужно сделать так, чтобы при запросе с сети ISP1 — пакеты шли обратно в ISP1, а не по другому интерфейсу.
Для этого нужно добавить ip rule(s):
Для этого создаем скрипты iprules:

Код /etc/network/if-up.d/iprules:

#!/bin/bash

ISP1_NETWORKS="10.0.5.0/24 175.5.25.0/27"
ISP2_NETWORKS="194.22.253.23/27 5.9.0.0/16"

if [ "${LOGICAL}" = "eth0" ]; then
    for NET in ${ISP1_NETWORKS}; do
        ip ru a from ${NET}  table ISP1  2>/dev/null 1>/dev/null
    done
fi

if [ "${LOGICAL}" = "eth1" ]; then
    for NET in ${ISP2_NETWORKS}; do
        ip ru a from ${NET}  table ISP2  2>/dev/null 1>/dev/null
    done
fi

Код /etc/network/if-down.d/iprules:

#!/bin/bash

ISP1_NETWORKS="10.0.5.0/24 175.5.25.0/27"
ISP2_NETWORKS="194.22.253.23/27 5.9.0.0/16"

if [ "${LOGICAL}" = "eth0" ]; then
    for NET in ${ISP1_NETWORKS}; do
        ip ru d from ${NET}  table ISP1  2>/dev/null 1>/dev/null
    done
fi

if [ "${LOGICAL}" = "eth1" ]; then
    for NET in ${ISP2_NETWORKS}; do
        ip ru d from ${NET}  table ISP2  2>/dev/null 1>/dev/null
    done
fi

Ставим флажок +x:

# chmod +x /etc/network/if-{up,down}.d/iprules

Теперь все ребутимзапускаем:

Чтобы не копипастить команды, сделаем хитрее:

# LOGICAL=eth0  /etc/network/if-up.d/iprules
# LOGICAL=eth2  /etc/network/if-up.d/iprules

Запускаем bird:

# invoke-rc.d bird start

Проверяем:

# ip r
10.0.5.0/24 via 10.10.10.1 dev eth0  proto bird
175.5.25.0/27 via 10.10.10.1 dev eth0  proto bird
194.22.253.23/27 via 172.17.5.1 dev eth2  proto bird
5.9.0.0/16 via 172.17.5.1 dev eth2  proto bird
10.10.10.0/24 dev eth0  proto kernel  scope link  src 10.10.10.106
172.17.5.0/24 dev eth2  proto kernel  scope link  src 172.17.5.105
192.168.254.0/24 dev eth1  proto kernel  scope link  src 192.168.254.254
default  proto bird
        nexthop via 10.10.10.1  dev eth0 weight 1
        nexthop via 172.17.5.1  dev eth2 weight 1

Теперь выдергиваем шнурокотключаем сетевой кабель от ISP1 (eth0), смотрим, что изменилось:

# ip r | grep -E "(default|nexthop)"
default  proto bird
        nexthop via 10.10.10.1  dev eth0 weight 1 dead
        nexthop via 172.17.5.1  dev eth2 weight 1

То есть, если один из провайдеров случайно отключился, трафик пойдет через другой, отключенный провайдер будет мониториться каждые 20 секунд (см. опцию scan time 20 в протоколах kernel) и при появлении автоматически уберет 'dead'.

В заключение: таким же образом, можно добавить и 10 провайдеров.

Автор: eZzZz

Источник

Поделиться

* - обязательные к заполнению поля